#pragma once

#include "VirtualSurfaceImageSourceRenderer.h"
#include "AliceParagraphGenerator.h"

class AliceVsisRenderer : public VirtualSurfaceImageSourceRenderer
{
public:
    AliceVsisRenderer(Windows::UI::Xaml::Media::Imaging::VirtualSurfaceImageSource^ vsis);

    void SetText(std::vector<std::wstring> lines);
    void SetWidth(float width);
    void SetDpi(float dpi);
    SIZE GetPixelSize();

protected:
    virtual void CreateDeviceResources() override;
    virtual void Render(D2D1_RECT_F updateRect) override;

private:
    AliceParagraphGenerator m_aliceParagraphGenerator;
    Microsoft::WRL::ComPtr<ID2D1SolidColorBrush> m_blackBrush;
    float m_width;
    int m_pixelWidth;
    int m_pixelHeight;

    void ResizeAndInvalidate();
};