﻿#include "pch.h"
#include "MainPage.xaml.h"

using namespace BounceScrollableAlice;

using namespace Concurrency;
using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::Graphics::Display;
using namespace Windows::Storage;
using namespace Windows::Storage::Streams;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Media::Imaging;
using namespace Windows::UI::Xaml::Navigation;

MainPage::MainPage() : m_dpi(96)
{
	InitializeComponent();
    
    // Create VirtualSurfaceImageSource to display text
    VirtualSurfaceImageSource^ vsis = ref new VirtualSurfaceImageSource(0, 0, true);
    img->Source = vsis;

    // Create AliceVsisRenderer based on that VirtualSurfaceImageSource
    m_vsisRenderer = new AliceVsisRenderer(vsis);
    m_vsisRenderer->Initialize();

    // Load in the text
    Loaded += ref new RoutedEventHandler([this] (Object^, Object^)
    {
        create_task(PathIO::ReadLinesAsync("ms-appx:///Text/AliceChapterVII-B.txt",
            UnicodeEncoding::Utf8))
            .then([this](IVector<String^>^ lines)
        {
            std::vector<std::wstring> vLines;

            for (String^ line : lines)
                vLines.push_back(std::wstring(line->Data()));

            m_vsisRenderer->SetText(vLines);
            SetImageSize();
        });
    });

    // Set a new width for the display
    SizeChanged += ref new SizeChangedEventHandler([this] (Object^, SizeChangedEventArgs^ args)
    {
        m_vsisRenderer->SetWidth(args->NewSize.Width);
        SetImageSize();
    });

    DisplayInformation^ displayInformation = DisplayInformation::GetForCurrentView();
    m_dpi = displayInformation->LogicalDpi;
    m_vsisRenderer->SetDpi(m_dpi);

    displayInformation->DpiChanged += ref new TypedEventHandler<DisplayInformation^, Object^>([this](DisplayInformation^ sender, Object^)
    {
        m_dpi = sender->LogicalDpi;
        m_vsisRenderer->SetDpi(m_dpi);
        SetImageSize();
    });
}

void MainPage::SetImageSize()
{
    SIZE pixelSize = m_vsisRenderer->GetPixelSize();
    img->Width = 96 * pixelSize.cx / m_dpi;
    img->Height = 96 * pixelSize.cy / m_dpi;
}
