#pragma once

class VirtualSurfaceImageSourceRenderer : public IVirtualSurfaceUpdatesCallbackNative
{
public:
    VirtualSurfaceImageSourceRenderer(Windows::UI::Xaml::Media::Imaging::VirtualSurfaceImageSource^ vsis);
    void Initialize();

    // IUnknown methods
    virtual ULONG STDMETHODCALLTYPE AddRef() override;
    virtual ULONG STDMETHODCALLTYPE Release() override;
    virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID uuid, void** object) override;

    // IVirutalSurfaceUpdatesCallbackNative method
    virtual HRESULT STDMETHODCALLTYPE UpdatesNeeded() override;

protected:
    float m_dpi;
    Microsoft::WRL::ComPtr<IVirtualSurfaceImageSourceNative>    m_vsisNative;
    Microsoft::WRL::ComPtr<ID3D11Device>                        m_d3dDevice;
    Microsoft::WRL::ComPtr<ID3D11DeviceContext>                 m_d3dContext;

    Microsoft::WRL::ComPtr<ID2D1Factory>                        m_d2dFactory;
    Microsoft::WRL::ComPtr<ID2D1Device>                         m_d2dDevice;
    Microsoft::WRL::ComPtr<ID2D1DeviceContext>                  m_d2dContext;

    virtual void CreateDeviceResources();
    virtual void SetDpi(float dpi);
    virtual void Render(D2D1_RECT_F updateRect) = 0;

private:
    ULONG m_refCount;
    void Draw(RECT updateRect);
};
