#pragma once

class FirstLineIndent : public IDWriteInlineObject
{
private:
    LONG m_refCount;
    int m_indent;

public:
    FirstLineIndent(int indent);

    // IUnknown methods
    ULONG STDMETHODCALLTYPE AddRef();
    ULONG STDMETHODCALLTYPE Release();
    HRESULT STDMETHODCALLTYPE QueryInterface(REFIID uuid, void** object);

    // IDWriteInlineObject methods
    HRESULT STDMETHODCALLTYPE GetMetrics(_Out_ DWRITE_INLINE_OBJECT_METRICS * metrics);

    HRESULT STDMETHODCALLTYPE GetOverhangMetrics(_Out_ DWRITE_OVERHANG_METRICS * overhangs);

    HRESULT STDMETHODCALLTYPE GetBreakConditions(_Out_ DWRITE_BREAK_CONDITION * breakConditionBefore,
                                                 _Out_ DWRITE_BREAK_CONDITION * breakConditionAfter);

    HRESULT STDMETHODCALLTYPE Draw(void * clientDrawingContext,
                                   IDWriteTextRenderer * renderer,
                                   FLOAT originX,
                                   FLOAT originY,
                                   BOOL isSideways,
                                   BOOL isRightToLeft,
                                   IUnknown * clientDrawingEffect);
};