﻿#pragma once

#include "DeviceResources.h"
#include "Content\ParagraphFormattedAliceRenderer.h"

namespace ParagraphFormattedAlice
{
	class ParagraphFormattedAliceMain : public IDeviceNotify
	{
	public:
		ParagraphFormattedAliceMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~ParagraphFormattedAliceMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRecreated();

        // Method called from DirectXPage to transfer text to renderer
        void SetAliceText(std::vector<std::wstring> lines);

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

		// Renderer class
        std::unique_ptr<ParagraphFormattedAliceRenderer> m_paragraphFormattedAliceRenderer;
	};
}