#pragma once

// #include <string>
#include "..\DeviceResources.h"

namespace PlainTextAlice
{
    class PlainTextAliceRenderer
    {
    public:
        PlainTextAliceRenderer(const std::shared_ptr<DeviceResources>& deviceResources);
        void CreateDeviceDependentResources();
        void CreateWindowSizeDependentResources();
        void ReleaseDeviceDependentResources();
        void Render();

        // Method to set text for rendering
        void SetAliceText(std::wstring text);

    private:
        // Cached pointer to device resources.
        std::shared_ptr<DeviceResources> m_deviceResources;

        // Device-dependent resources
        Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_blackBrush;
        Microsoft::WRL::ComPtr<ID2D1DrawingStateBlock>  m_stateBlock;

        std::wstring                                    m_text;
        D2D1_RECT_F                                     m_layoutRect;
        Microsoft::WRL::ComPtr<IDWriteTextFormat>		m_textFormat;
    };
}