﻿#pragma once

#include "Common\StepTimer.h"
#include "DeviceResources.h"
#include "Content\PlainTextAliceRenderer.h"

// Renders Direct2D and 3D content on the screen.
namespace PlainTextAlice
{
	class PlainTextAliceMain : public IDeviceNotify
	{
	public:
		PlainTextAliceMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~PlainTextAliceMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRecreated();

        // Method called from DirectXPage to transfer text to renderer
        void SetAliceText(std::wstring text);

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

        // Renderer class
        std::unique_ptr<PlainTextAliceRenderer> m_PlainTextAliceRenderer;
	};
}