﻿#pragma once

#include "DeviceResources.h"
#include "Content\ScrollableAliceRenderer.h"

namespace ScrollableAlice
{
	class ScrollableAliceMain : public IDeviceNotify
	{
	public:
		ScrollableAliceMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~ScrollableAliceMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

        // IDeviceNotify
        virtual void OnDeviceLost();
        virtual void OnDeviceRecreated();

        // Methods called from DirectXPage
        void SetAliceText(std::vector<std::wstring> lines);
        void ScrollVerticalDelta(float deltaY);

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

		// Renderer class
		std::unique_ptr<ScrollableAliceRenderer> m_ScrollableAliceRenderer;

        void CalculateMaxScrollOffset();
        void RenderScrolledOutput();

        float m_maxScrollOffset;
        float m_scrollOffset;
	};
}